<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Fetch API</title>
  <link rel="stylesheet" type="text/css" href="./index.css" media="screen" />
</head>

<body>
  <header>
    <h1>Notebook</h1>
  </header>

  <main>
    <form id="form">
      <label for="title">Title</label>
      <input type="text" id="title" name="title" required>

      <br />

      <label for="body">Body</label>
      <textarea id="body" name="body" rows="4" required></textarea>

      <br />

      <button type="submit">Add Note</button>
    </form>

    <section>
      <h2>Notes</h2>
      <ul id="notes">
      </ul>
    </section>
  </main>

  <script>
    function handleSubmit(event) {
      event.preventDefault()

      const form = document.getElementById('form')
      const titleInput = document.getElementById('title')
      const bodyInput = document.getElementById('body')

      const title = titleInput.value
      const body = bodyInput.value

      createNote(title, body)
        .then(function (note) {
          const notesList = document.getElementById('notes')
          const listItem = document.createElement('li')
          listItem.textContent = note.title
          listItem.setAttribute('data-id', note.id)
          notesList.appendChild(listItem)

          form.reset()
        })
        .catch(function (error) {
          console.error('Error creating note:', error)
        })
    }

    const form = document.getElementById('form')
    form.addEventListener('submit', handleSubmit)
  </script>

  <script>
    function handleNoteClick(event) {
      const noteId = event.target.getAttribute('data-id')

      fetchNote(noteId)
        .then(function (note) {
          const dialog = document.createElement('dialog')
          const titleElement = document.createElement('h2')
          const bodyElement = document.createElement('p')
          const closeButton = document.createElement('button')

          titleElement.textContent = note.title
          bodyElement.textContent = note.body
          closeButton.textContent = 'Close'

          closeButton.addEventListener('click', function () {
            dialog.close()
          })

          dialog.appendChild(titleElement)
          dialog.appendChild(bodyElement)
          dialog.appendChild(closeButton)

          document.body.appendChild(dialog)

          dialog.showModal()
        })
        .catch(function (error) {
          console.error('Error fetching note:', error)
        })
    }

    const notesList = document.getElementById('notes')
    notesList.addEventListener('click', handleNoteClick)
  </script>

  <script>
    function createNote(title, body) {
      const options = {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json'
        },
        body: JSON.stringify({
          data: {
            title,
            body
          }
        })
      }

      return fetch('https://api.restful-api.dev/objects', options)
        .then(function (response) {
          if (response.ok) {
            return response.json()
          } else {
            throw new Error('Error: ' + response.status)
          }
        })
        .then(response => ({ id: response.id, ...response.data }))
    }
  </script>

  <script>
    function fetchNote(noteId) {
      return fetch(`https://api.restful-api.dev/objects/${noteId}`)
        .then(function (response) {
          if (response.ok) {
            return response.json()
          } else {
            throw new Error('Error: ' + response.status)
          }
        })
        .then(response => response.data)
    }
  </script>

</body>

</html>
